// ----------------------------------------------------------------------------
// Input.java
// test program for line-oriented input
// 
// Author:  Wolfgang Schreiner <Wolfgang.Schreiner@fhs-hagenberg.ac.at>
// Created: August 19, 2001
// ----------------------------------------------------------------------------
class InputMain
{
  // -------------------------------------------------------------------------
  // test program: iteratively 
  // - reads character [B|b|s|i|l|f|d|S]
  // - reads element of type denoted by character
  // - prints element respectively error message
  // terminating by pressing <ctrl-d> (end of input)
  // -------------------------------------------------------------------------
  public static void main(String argc[])
  {
    while (true)
    {
      System.out.print("Enter [B|c|b|s|i|l|f|d|S]: ");
      char c = Input.readChar();
      if (Input.hasEnded()) break;
      if (!Input.isOkay()) 
      {
        Input.clearError(); 
        continue;
      }
      switch (c)
      {
      case 'B':
      {
        System.out.print("Enter boolean: ");
        boolean b = Input.readBoolean();
        if (Input.isOkay()) System.out.println("Okay: " + b);
        break;
      }
      case 'c':
      {
        System.out.print("Enter char: ");
        char ch = Input.readChar();
        if (Input.isOkay()) System.out.println("Okay: " + ch);
        break;
      }
      case 'b':
      {
        System.out.print("Enter byte: ");
        byte b = Input.readByte();
        if (Input.isOkay()) System.out.println("Okay: " + b);
        break;
      }
      case 's':
      {
        System.out.print("Enter short: ");
        short s = Input.readShort();
        if (Input.isOkay()) System.out.println("Okay: " + s);
        break;
      }
      case 'i':
      {
        System.out.print("Enter int: ");
        int i = Input.readInt();
        if (Input.isOkay()) System.out.println("Okay: " + i);
        break;
      }
      case 'l':
      {
        System.out.print("Enter long: ");
        long l = Input.readLong();
        if (Input.isOkay()) System.out.println("Okay: " + l);
        break;
      }
      case 'f':
      {
        System.out.print("Enter float: ");
        float f = Input.readFloat();
        if (Input.isOkay()) System.out.println("Okay: " + f);
        break;
      }
      case 'd':
      {
        System.out.print("Enter double: ");
        double d = Input.readDouble();
        if (Input.isOkay()) System.out.println("Okay: " + d);
        break;
      }
      case 'S':
      {
        System.out.print("Enter string: ");
        String s = Input.readString();
        if (Input.isOkay()) System.out.println("Okay: " + s);
        break;
      }
      }
      if (!Input.isOkay())
      {
        if (Input.hasEnded()) return;
        System.out.println("Error: " + Input.getError());
        Input.clearError();
      }
    }
    System.out.println("\nTerminated.");
  }
}





